Open CASCADE Technology  7.3.1.dev
Public Member Functions
BRepBuilderAPI_MakeWire Class Reference

Describes functions to build wires from edges. A wire can be built from any number of edges. To build a wire you first initialize the construction, then add edges in sequence. An unlimited number of edges can be added. The initialization of construction is done with: More...

#include <BRepBuilderAPI_MakeWire.hxx>

Inheritance diagram for BRepBuilderAPI_MakeWire:
Inheritance graph
[legend]

Public Member Functions

 BRepBuilderAPI_MakeWire ()
 Constructs an empty wire framework, to which edges are added using the Add function. As soon as the wire contains one edge, it can return with the use of the function Wire. Warning The function Error will return BRepBuilderAPI_EmptyWire if it is called before at least one edge is added to the wire under construction. More...
 
 BRepBuilderAPI_MakeWire (const TopoDS_Edge &E)
 Make a Wire from an edge. More...
 
 BRepBuilderAPI_MakeWire (const TopoDS_Edge &E1, const TopoDS_Edge &E2)
 Make a Wire from two edges. More...
 
 BRepBuilderAPI_MakeWire (const TopoDS_Edge &E1, const TopoDS_Edge &E2, const TopoDS_Edge &E3)
 Make a Wire from three edges. More...
 
 BRepBuilderAPI_MakeWire (const TopoDS_Edge &E1, const TopoDS_Edge &E2, const TopoDS_Edge &E3, const TopoDS_Edge &E4)
 Make a Wire from four edges. Constructs a wire. More...
 
 BRepBuilderAPI_MakeWire (const TopoDS_Wire &W)
 Make a Wire from a Wire. Usefull for adding later. More...
 
 BRepBuilderAPI_MakeWire (const TopoDS_Wire &W, const TopoDS_Edge &E)
 Add an edge to a wire. More...
 
void Add (const TopoDS_Edge &E)
 Adds the edge E to the wire under construction. E must be connectable to the wire under construction, and, unless it is the first edge of the wire, must satisfy the following condition: one of its vertices must be geometrically coincident with one of the vertices of the wire (provided that the highest tolerance factor is assigned to the two vertices). It could also be the same vertex. Warning If E is not connectable to the wire under construction it is not added. The function Error will return BRepBuilderAPI_DisconnectedWire, the function IsDone will return false and the function Wire will raise an error, until a new connectable edge is added. More...
 
void Add (const TopoDS_Wire &W)
 Add the edges of <W> to the current wire. More...
 
void Add (const TopTools_ListOfShape &L)
 Adds the edges of <L> to the current wire. The edges are not to be consecutive. But they are to be all connected geometrically or topologically. If some of them are not connected the Status give DisconnectedWire but the "Maker" is Done() and you can get the partial result. (ie connected to the first edgeof the list <L>) More...
 
virtual Standard_Boolean IsDone () const override
 Returns true if this algorithm contains a valid wire. IsDone returns false if: More...
 
BRepBuilderAPI_WireError Error () const
 Returns the construction status. More...
 
const TopoDS_WireWire ()
 Returns the constructed wire; or the part of the wire under construction already built. Exceptions StdFail_NotDone if a wire is not built. More...
 
 operator TopoDS_Wire ()
 
const TopoDS_EdgeEdge () const
 Returns the last edge added to the wire under construction. Warning. More...
 
const TopoDS_VertexVertex () const
 Returns the last vertex of the last edge added to the wire under construction. Warning A null vertex is returned if there are no edges in the wire under construction, or if the last edge which you tried to add was not connectableR. More...
 
- Public Member Functions inherited from BRepBuilderAPI_MakeShape
virtual void Build ()
 This is called by Shape(). It does nothing but may be redefined. More...
 
virtual const TopoDS_ShapeShape ()
 Returns a shape built by the shape construction algorithm. Raises exception StdFail_NotDone if the shape was not built. More...
 
 operator TopoDS_Shape ()
 
virtual const TopTools_ListOfShapeGenerated (const TopoDS_Shape &S)
 Returns the list of shapes generated from the shape <S>. More...
 
virtual const TopTools_ListOfShapeModified (const TopoDS_Shape &S)
 Returns the list of shapes modified from the shape <S>. More...
 
virtual Standard_Boolean IsDeleted (const TopoDS_Shape &S)
 Returns true if the shape S has been deleted. More...
 
- Public Member Functions inherited from BRepBuilderAPI_Command
virtual ~BRepBuilderAPI_Command ()
 
void Check () const
 Raises NotDone if done is false. More...
 

Additional Inherited Members

- Protected Member Functions inherited from BRepBuilderAPI_MakeShape
 BRepBuilderAPI_MakeShape ()
 
- Protected Member Functions inherited from BRepBuilderAPI_Command
 BRepBuilderAPI_Command ()
 Set done to False. More...
 
void Done ()
 Set done to true. More...
 
void NotDone ()
 Set done to false. More...
 
- Protected Attributes inherited from BRepBuilderAPI_MakeShape
TopoDS_Shape myShape
 
TopTools_ListOfShape myGenerated
 

Detailed Description

Describes functions to build wires from edges. A wire can be built from any number of edges. To build a wire you first initialize the construction, then add edges in sequence. An unlimited number of edges can be added. The initialization of construction is done with:

Constructor & Destructor Documentation

◆ BRepBuilderAPI_MakeWire() [1/7]

BRepBuilderAPI_MakeWire::BRepBuilderAPI_MakeWire ( )

Constructs an empty wire framework, to which edges are added using the Add function. As soon as the wire contains one edge, it can return with the use of the function Wire. Warning The function Error will return BRepBuilderAPI_EmptyWire if it is called before at least one edge is added to the wire under construction.

◆ BRepBuilderAPI_MakeWire() [2/7]

BRepBuilderAPI_MakeWire::BRepBuilderAPI_MakeWire ( const TopoDS_Edge E)

Make a Wire from an edge.

◆ BRepBuilderAPI_MakeWire() [3/7]

BRepBuilderAPI_MakeWire::BRepBuilderAPI_MakeWire ( const TopoDS_Edge E1,
const TopoDS_Edge E2 
)

Make a Wire from two edges.

◆ BRepBuilderAPI_MakeWire() [4/7]

BRepBuilderAPI_MakeWire::BRepBuilderAPI_MakeWire ( const TopoDS_Edge E1,
const TopoDS_Edge E2,
const TopoDS_Edge E3 
)

Make a Wire from three edges.

◆ BRepBuilderAPI_MakeWire() [5/7]

BRepBuilderAPI_MakeWire::BRepBuilderAPI_MakeWire ( const TopoDS_Edge E1,
const TopoDS_Edge E2,
const TopoDS_Edge E3,
const TopoDS_Edge E4 
)

Make a Wire from four edges. Constructs a wire.

  • from the TopoDS_Wire W composed of the edge E, or
  • from edge E, or
  • from two edges E1 and E2, or
  • from three edges E1, E2 and E3, or
  • from four edges E1, E2, E3 and E4. Further edges can be added using the function Add. Given edges are added in a sequence. Each of them must be connectable to the wire under construction, and so must satisfy the following condition (unless it is the first edge of the wire): one of its vertices must be geometrically coincident with one of the vertices of the wire (provided that the highest tolerance factor is assigned to the two vertices). It could also be the same vertex. Warning If an edge is not connectable to the wire under construction it is not added. The function Error will return BRepBuilderAPI_DisconnectedWire, the function IsDone will return false and the function Wire will raise an error, until a new connectable edge is added.

◆ BRepBuilderAPI_MakeWire() [6/7]

BRepBuilderAPI_MakeWire::BRepBuilderAPI_MakeWire ( const TopoDS_Wire W)

Make a Wire from a Wire. Usefull for adding later.

◆ BRepBuilderAPI_MakeWire() [7/7]

BRepBuilderAPI_MakeWire::BRepBuilderAPI_MakeWire ( const TopoDS_Wire W,
const TopoDS_Edge E 
)

Add an edge to a wire.

Member Function Documentation

◆ Add() [1/3]

void BRepBuilderAPI_MakeWire::Add ( const TopoDS_Edge E)

Adds the edge E to the wire under construction. E must be connectable to the wire under construction, and, unless it is the first edge of the wire, must satisfy the following condition: one of its vertices must be geometrically coincident with one of the vertices of the wire (provided that the highest tolerance factor is assigned to the two vertices). It could also be the same vertex. Warning If E is not connectable to the wire under construction it is not added. The function Error will return BRepBuilderAPI_DisconnectedWire, the function IsDone will return false and the function Wire will raise an error, until a new connectable edge is added.

◆ Add() [2/3]

void BRepBuilderAPI_MakeWire::Add ( const TopoDS_Wire W)

Add the edges of <W> to the current wire.

◆ Add() [3/3]

void BRepBuilderAPI_MakeWire::Add ( const TopTools_ListOfShape L)

Adds the edges of <L> to the current wire. The edges are not to be consecutive. But they are to be all connected geometrically or topologically. If some of them are not connected the Status give DisconnectedWire but the "Maker" is Done() and you can get the partial result. (ie connected to the first edgeof the list <L>)

◆ Edge()

const TopoDS_Edge& BRepBuilderAPI_MakeWire::Edge ( ) const

Returns the last edge added to the wire under construction. Warning.

  • This edge can be different from the original one (the argument of the function Add, for instance,)
  • A null edge is returned if there are no edges in the wire under construction, or if the last edge which you tried to add was not connectable..

◆ Error()

BRepBuilderAPI_WireError BRepBuilderAPI_MakeWire::Error ( ) const

Returns the construction status.

  • BRepBuilderAPI_WireDone if the wire is built, or
  • another value of the BRepBuilderAPI_WireError enumeration indicating why the construction failed.

◆ IsDone()

virtual Standard_Boolean BRepBuilderAPI_MakeWire::IsDone ( ) const
overridevirtual

Returns true if this algorithm contains a valid wire. IsDone returns false if:

  • there are no edges in the wire, or
  • the last edge which you tried to add was not connectable.

Reimplemented from BRepBuilderAPI_Command.

◆ operator TopoDS_Wire()

BRepBuilderAPI_MakeWire::operator TopoDS_Wire ( )

◆ Vertex()

const TopoDS_Vertex& BRepBuilderAPI_MakeWire::Vertex ( ) const

Returns the last vertex of the last edge added to the wire under construction. Warning A null vertex is returned if there are no edges in the wire under construction, or if the last edge which you tried to add was not connectableR.

◆ Wire()

const TopoDS_Wire& BRepBuilderAPI_MakeWire::Wire ( )

Returns the constructed wire; or the part of the wire under construction already built. Exceptions StdFail_NotDone if a wire is not built.


The documentation for this class was generated from the following file: